unit Unit1;
//===========================================//
//===== DD:Delphi GjM@d  =====//
//===== @:Lէe                     =====//
//===== ɮצW:DpBTreeDemo.ZIP        =====//
//=====                                 =====//
//===========================================//
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type

  TNodePtr = ^TNode;
  TNode = Object
    RecCount    :integer;
    ParentPtr   :TNodePtr;
    LeftNodePtr :TNodePtr;
    RightNodePtr:TNodePtr;
    KeyValue:string;
    procedure ClearNode;
  end;

  TForm1 = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    Label3: TLabel;
    Label4: TLabel;
    Edit3: TEdit;
    Button3: TButton;
    Button4: TButton;
    Button2: TButton;
    ListBox1: TListBox;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1:TForm1;
  Root :TNodePtr;

implementation

{$R *.dfm}

function FindNode(var RootPtr:TNodePtr;Key,Data:string):boolean;
var NodePtr:TNodePtr;
    Label Loop1;
begin
  result := FALSE;
  NodePtr := RootPtr;
  Loop1:
    if(NodePtr <> nil)then
      begin
        if(Key = NodePtr^.KeyValue)then
          begin
            result := TRUE;
            ShowMessage('Find !! ('+NodePtr^.KeyValue+') !!');
            Exit;
          end;//if...end!!
        //------------------------------
        if(Key > NodePtr^.KeyValue)then
          begin
            NodePtr := NodePtr^.RightNodePtr;
            Goto Loop1;
          end;//if...end!!
        if(Key < NodePtr^.KeyValue)then
          begin
            NodePtr := NodePtr^.LeftNodePtr;
            Goto Loop1;
          end;//if...end!!
      end;//if...end!!
end;

function DeleteNode(var RootPtr:TNodePtr;Key,Data:string):boolean;
var NewRootPtr,tmpPtr,NodePtr:TNodePtr;
    Label Loop1,Loop2,Loop3;
begin
  result := FALSE;
  NodePtr := RootPtr;
  if(RootPtr = nil)then Exit;
  if(Key <> RootPtr^.KeyValue)then
    begin
      Loop1:
        if(NodePtr <> nil)then
          begin
            if(Key = NodePtr^.KeyValue)then
              begin
                if(NodePtr^.LeftNodePtr <> nil)then
                  begin
                    NodePtr^.LeftNodePtr^.ParentPtr := NodePtr^.ParentPtr;
                    //--------------------------------------------------------------
                    if(NodePtr^.ParentPtr^.LeftNodePtr = NodePtr)then
                      NodePtr^.ParentPtr^.LeftNodePtr := NodePtr^.LeftNodePtr;
                    //--------------------------------------------------------------
                    if(NodePtr^.ParentPtr^.RightNodePtr = NodePtr)then
                      NodePtr^.ParentPtr^.RightNodePtr := NodePtr^.LeftNodePtr;
                    //--------------------------------------------------------------
                    if(NodePtr^.RightNodePtr <> nil)then
                      begin
                        tmpPtr := NodePtr^.LeftNodePtr;
                        Loop2:
                          if(tmpPtr^.RightNodePtr = nil)then
                            begin
                              NodePtr^.RightNodePtr^.ParentPtr := tmpPtr;
                              tmpPtr^.RightNodePtr := NodePtr^.RightNodePtr;
                              tmpPtr := nil;
                            end//if...end!!
                          else
                            begin
                              tmpPtr := tmpPtr^.RightNodePtr;
                              Goto Loop2;
                            end;//if...else...end!!
                      end;//if...end!!
                    //--------------------------------------------------------------  
                  end//if...end
                else
                  if(NodePtr^.RightNodePtr <> nil)then
                    begin
                      NodePtr^.RightNodePtr^.ParentPtr := NodePtr^.ParentPtr;
                      //--------------------------------------------------------------
                      if(NodePtr^.ParentPtr^.LeftNodePtr = NodePtr)then
                        NodePtr^.ParentPtr^.LeftNodePtr := NodePtr^.RightNodePtr;
                      //--------------------------------------------------------------
                      if(NodePtr^.ParentPtr^.RightNodePtr = NodePtr)then
                        NodePtr^.ParentPtr^.RightNodePtr := NodePtr^.RightNodePtr;
                    //--------------------------------------------------------------
                    end;//if...end!!
                RootPtr^.RecCount := RootPtr^.RecCount-1;

                ShowMessage('Delete !! ('+NodePtr^.KeyValue+') !!');
                DisPose(NodePtr);
                result := TRUE;
                Exit;
              end;//if...end!!
            //------------------------------
            if(Key > NodePtr^.KeyValue)then
              begin
                NodePtr := NodePtr^.RightNodePtr;
                Goto Loop1;
              end;//if...end!!
            if(Key < NodePtr^.KeyValue)then
              begin
                NodePtr := NodePtr^.LeftNodePtr;
                Goto Loop1;
              end;//if...end!!
          end;//if...end!!
    end//if...end!!
  else   //if Delete Node is Root !!
    begin
      if(RootPtr^.RightNodePtr <> nil)then
        begin
          NewRootPtr := RootPtr^.RightNodePtr;
          if(RootPtr^.RightNodePtr^.LeftNodePtr = nil)then
            begin
              RootPtr^.RightNodePtr^.LeftNodePtr := RootPtr^.LeftNodePtr;
            end
          else
            begin
              tmpPtr := RootPtr^.RightNodePtr^.LeftNodePtr;
              Loop3:
                if(tmpPtr^.LeftNodePtr = nil)then
                  begin
                    tmpPtr^.LeftNodePtr := RootPtr^.LeftNodePtr;
                    RootPtr^.LeftNodePtr^.ParentPtr := tmpPtr;
                    tmpPtr := nil;
                  end //if...end!!
                else
                  begin
                    tmpPtr := tmpPtr^.LeftNodePtr;
                    Goto Loop3;
                  end;//else...end!!
            end;//else...end!!
          RootPtr^.RightNodePtr^.ParentPtr   := nil;
          RootPtr^.RightNodePtr^.RecCount    := RootPtr^.RecCount-1;
          if(RootPtr^.LeftNodePtr <> nil)then
            RootPtr^.LeftNodePtr^.ParentPtr := RootPtr^.LeftNodePtr;
          Dispose(RootPtr);
          RootPtr := nil;
          RootPtr := NewRootPtr;
          tmpPtr  := nil;
        end //if...end!!
      else
        if(RootPtr^.LeftNodePtr <> nil)then
          begin
            NewRootPtr := RootPtr^.LeftNodePtr;
            NewRootPtr^.ParentPtr := nil;
            NewRootPtr^.RecCount := RootPtr^.RecCount-1;
            Dispose(RootPtr);
            RootPtr := nil;
            RootPtr := NewRootPtr;
            tmpPtr  := nil;
          end;//if...end!!

    end;//else...end!!
end;

function InsertDataToBTree(var RootPtr:TNodePtr;Key:string):boolean;
var NodePtr:TNodePtr;
    Label Loop;
begin
  result := FALSE;
  if(RootPtr = nil)then
    begin
       New(RootPtr);
       RootPtr^.ClearNode;
       RootPtr^.RecCount := 1;
       RootPtr^.KeyValue := Key;
       result := TRUE;
    end//if...end!!
  else
    begin
      NodePtr := RootPtr;
      Loop:
        if(Key < NodePtr^.KeyValue)then
          begin
            if(NodePtr^.LeftNodePtr = nil)then
              begin
                New(NodePtr^.LeftNodePtr);
                NodePtr^.LeftNodePtr^.ClearNode;
                NodePtr^.LeftNodePtr^.ParentPtr := NodePtr;
                NodePtr^.LeftNodePtr^.KeyValue  := Key;
                RootPtr^.RecCount := RootPtr^.RecCount+1;
                result := TRUE;
              end//if...end!!
            else
              begin
                NodePtr := NodePtr^.LeftNodePtr;
                GoTo Loop;
              end;//else...end!!
          end//if...end!!
        else
          if(Key = NodePtr^.KeyValue)then
            begin
              result := FALSE;
              //show Error Message();
            end//if...end!!
          else
            if(Key > NodePtr^.KeyValue)then
              begin
                if(NodePtr^.RightNodePtr = nil)then
                  begin
                    New(NodePtr^.RightNodePtr);
                    NodePtr^.RightNodePtr^.ClearNode;
                    NodePtr^.RightNodePtr^.ParentPtr := NodePtr;
                    NodePtr^.RightNodePtr^.KeyValue  := Key;
                    RootPtr^.RecCount := RootPtr^.RecCount+1;
                    result := TRUE;
                  end//if...end!!
                else
                  begin
                    NodePtr := NodePtr^.RightNodePtr;
                    GoTo Loop;
                  end;//else...end!!
              end;//if...end!!
      NodePtr := nil;
    end;//else...end!!
end;

procedure DestroyTree(var RootPtr:TNodePtr);
var tmpNodePtr,TargetNodePtr:TNodePtr;
    str:string;
    Label Loop1,Loop2;
begin
  if(RootPtr = nil)then Exit;
  TargetNodePtr := RootPtr;
  Loop1:
    if(TargetNodePtr^.LeftNodePtr = nil)
      and(TargetNodePtr^.RightNodePtr = nil)then
      begin
        tmpNodePtr := TargetNodePtr^.ParentPtr;
        if(tmpNodePtr <> nil)then
          begin
            if(TargetNodePtr = tmpNodePtr^.LeftNodePtr)then
              tmpNodePtr^.LeftNodePtr := nil;
            if(TargetNodePtr = tmpNodePtr^.RightNodePtr)then
              tmpNodePtr^.RightNodePtr := nil;
            str := TargetNodePtr^.ParentPtr.KeyValue;
          end
        else
          begin
            RootPtr := nil;
            str := 'nil';
          end;
        //ShowMessage('Free '+TargetNodePtr^.KeyValue
        //            +#10+#13
        //            +'Parent '+str);
        DisPose(TargetNodePtr);
        TargetNodePtr := tmpNodePtr;
        tmpNodePtr := nil;
        if(TargetNodePtr <> nil)then Goto Loop1;
      end//if...end!!
    else
      begin
        Loop2:
          if(TargetNodePtr^.LeftNodePtr <> nil)then
            begin
              TargetNodePtr := TargetNodePtr^.LeftNodePtr;
              Goto Loop2;
            end;
          if(TargetNodePtr^.RightNodePtr <> nil)then
            begin
              TargetNodePtr := TargetNodePtr^.RightNodePtr;
              Goto Loop2;
            end;
        if(TargetNodePtr^.LeftNodePtr = nil)
          and(TargetNodePtr^.RightNodePtr = nil)then
          Goto Loop1;
      end;//else...end!!
end;

//TNode.
procedure TNode.ClearNode;
begin
  self.RecCount       := 0;
  self.KeyValue       := '';
  self.LeftNodePtr    := nil;
  self.RightNodePtr   := nil;
  self.ParentPtr      := nil;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if(InsertDataToBTree(Root,Edit1.Text) = TRUE)then
    Label3.Caption := 'Record Count = '+IntToStr(Root^.RecCount);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  FindNode(Root,Edit3.Text,'');
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  if(DeleteNode(Root,Edit3.Text,'') = TRUE)then
    if(root = nil)then Label3.Caption := 'Record Count = 0'
    else Label3.Caption := 'Record Count = '+IntToStr(Root^.RecCount);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  DestroyTree(Root);
end;

procedure TForm1.Button2Click(Sender: TObject);
var i:integer;
begin
  for i := 0 to ListBox1.Items.Count-1 do
    begin
      ListBox1.ItemIndex := i;
      if(InsertDataToBTree(Root,ListBox1.Items[i]) = TRUE)then
        Label3.Caption := 'Record Count = '+IntToStr(Root^.RecCount);
    end;    
end;

procedure TForm1.ListBox1Click(Sender: TObject);
begin
  if(ListBox1.ItemIndex >= 0)then
    Edit3.Text := ListBox1.Items[ListBox1.ItemIndex];
end;

end.
